SystemOrganization addCategory: #'Summer2010-STdoc'!
SystemOrganization addCategory: #'Summer2010-Morph'!

PolygonMorph subclass: #Liaison
	instanceVariableNames: 'source destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-Morph'!

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:00'!
destination
	^ destination! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:01'!
destination: aMyRoundedMorph
	destination := aMyRoundedMorph.
	aMyRoundedMorph addLine: self.! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 15:06'!
draw
	self delete.
	self vertices: {self source center. self destination center}
			color: Color black borderWidth: 2 borderColor: (Color black).
	self openInWorld.
	self passivate.! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:12'!
initialize

	super initialize.
	self beSticky.! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:00'!
source
	^ source! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 13:29'!
source: aMyRoundedMorph
	source := aMyRoundedMorph.
	aMyRoundedMorph addLine: self.! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/17/2010 03:17'!
step

	self source isNil | self destination isNil
	ifFalse: [self draw].! !

!Liaison methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/17/2010 02:55'!
stepTime
	^ 250.! !

Object subclass: #MorphFire
	instanceVariableNames: 'tableau taille dissipation sleepTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-Morph'!

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 16:53'!
delete
	(1 to: tableau size) do:
	[:i|
		(1 to: (tableau at: 1) size) do:
		[:j|
			((tableau at: i) at: j) delete.
		]
	
	]! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
dissipation
	^ dissipation! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
dissipation: anObject
	dissipation := anObject! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 20:13'!
drawFlame
| blockClosure clockProcess |

blockClosure :=
        [|awakeTime aDelay |
        awakeTime := self sleepTime.

        (tableau size) timesRepeat: 
							[self initColor.
							 self majColor.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:40'!
drawFlame2
| blockClosure clockProcess |
self initColor .
blockClosure :=
        [|awakeTime aDelay |
        awakeTime := self sleepTime.

         (tableau size) timesRepeat: 
							[self majColor2.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:55'!
drawFlames
| blockClosure clockProcess |
blockClosure :=
        [|awakeTime aDelay |
        awakeTime := 2 * self sleepTime.

        (tableau size) timesRepeat: 
							[self drawFlame2.
                        aDelay := Delay forMilliseconds: awakeTime.
                        aDelay wait.]].
clockProcess := blockClosure newProcess.
clockProcess resume
	
	! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 19:46'!
initColor
	|ligne median start|
	
	median := (((tableau at:1) size)*0.8)asInteger.
	start := ((tableau at:1) size) - median.
	
	Transcript show: 'start : ', start asString ; cr.
	Transcript show: 'median : ', median asString ; cr.
	
	ligne := tableau at: (tableau size).
	(1 to: start) do:
	[:i|
		(ligne at:i) color:(Color r:( Random new nextValue / 3000000000 -1) g:0 b:0);hide.	
	].
	(start to: median+start) do:
	[:i|
		(ligne at:i) color:(Color r: ( Random new nextValue / 1000000000 -1)g: 0 b:0);hide.	
	].
	(median+start to: ligne size) do:
	[:i|
		(ligne at:i) color:(Color r:( Random new nextValue / 3000000000 -1) g:0 b:0);hide.	
	].! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/14/2010 14:59'!
initialize
	|nblignes nbcolonnes initX initY tempX tempY|

	nblignes := 50.
	nbcolonnes := 100.
	self taille: 1.
	
	initX := 50.
	initY := 50.
	self dissipation: 0.95.
	self sleepTime: 500.
	
	tableau := Array new: nblignes. "colone"
	(1 to: nblignes) do:
	[:i|
		tableau at: i put: (Array new: nbcolonnes).	 "ligne"
	].

	(1 to:  nblignes) do:
	[:col|
		(1 to: nbcolonnes) do:
		[:lig|
			tempX := (initX + (taille*lig)).
			tempY := (initY + (taille*col)).
			(tableau at: col) at: lig put: (Morph new bounds: ((tempX@tempY) corner: (tempX + taille)@ (tempY + taille))).
			((tableau at: col) at: lig) dragEnabled: false;openInWorld.
		]
	]! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/14/2010 14:57'!
majColor
|ligne moy diss seuil|

	seuil := 0.15.

	diss := self dissipation.

	(1 to: tableau size -1) do:
	[:i|
		ligne := tableau at: i.
		"first case"
		moy := ((((tableau at:i+1) at: 1) color red)  + (((tableau at:i+1) at: 2)) color red)/3.
		moy := moy * diss.
		(ligne at: 1) color: (Color r:moy g:0 b:0).
		"last case"
		moy := ((((tableau at:i+1) at: ((tableau at:i+1) size) ) color red)  + (((tableau at:i+1) at: ((tableau at:i+1) size-1))) color red)/3.
		moy := moy * diss.
		(ligne at: (ligne size)) color: (Color r:moy g:0 b:0).
		
		((ligne at:1) color red) +  ((ligne at:1) color blue)  + ((ligne at:1) color green) < seuil
		ifTrue:[(ligne at:1) hide]
		ifFalse:[(ligne at:1)show].
		
		((ligne at:(ligne size)) color red) +  ((ligne at:(ligne size)) color blue) + ((ligne at:(ligne size)) color green) < seuil
		ifTrue:[(ligne at:(ligne size)) hide]
		ifFalse:[(ligne at:(ligne size))show].
		
		(2 to: ligne size-1) do:
		[:j|
			moy := moy := ((((tableau at:i+1) at: j-1) color red)  + (((tableau at:i+1) at: j)) color red) + ((((tableau at:i+1) at: j+1)) color red)/3.
			moy := moy * diss.
			(ligne at: j) color: (Color r:moy g:0 b:0).
			((ligne at:j) color red) +  ((ligne at:j) color blue) + ((ligne at:j) color green) < seuil
		ifTrue:[(ligne at:j) hide]
		ifFalse:[(ligne at:j)show].
		]
	]! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/12/2010 19:41'!
majColor2
|ligne moy diss|

	diss := self dissipation.

	(2 to: tableau size -1) do:
	[:i|
		ligne := tableau at: i.
		"first case"
		moy := ((((tableau at:i+1) at: 1) color red)  + (((tableau at:i+1) at: 2) color red) + (((tableau at:i) at: 2) color red) + (((tableau at:i-1) at: 1) color red) + (((tableau at:i-1) at: 2) color red))/8.
		moy := moy * diss.
		(ligne at: 1) color: (Color r:moy g:0 b:0).
		"last case"
		moy := ((((tableau at:i+1) at: ((tableau at:i+1) size) ) color red)  + (((tableau at:i+1) at: ((tableau at:i+1) size-1) ) color red) + (((tableau at:i-1) at: ((tableau at:i-1) size) ) color red)+ (((tableau at:i-1) at: ((tableau at:i-1) size-1) + (((tableau at:i) at: ((tableau at:i) size-1) ) color red)) color red))/8.
		moy := moy * diss.
		(ligne at: (ligne size)) color: (Color r:moy g:0 b:0).
		
		
		(2 to: ligne size-1) do:
		[:j|
			moy := moy := (((((tableau at:i+1) at: j-1) color red)  + (((tableau at:i+1) at: j)) color red) + (((tableau at:i+1) at: j+1) color red) + (((tableau at:i) at: j-1) color red) + (((tableau at:i) at: j+1) color red) + (((tableau at:i-1) at: j-1) color red) + (((tableau at:i-1) at: j) color red)+ (((tableau at:i-1) at: j+1) color red))/8.
			moy := moy * diss.
			(ligne at: j) color: (Color r:moy g:0 b:0).
		]
	]! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:10'!
sleepTime
	^ sleepTime! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:10'!
sleepTime: anObject
	sleepTime := anObject! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/14/2010 14:55'!
step
"|i|
	i isNil
	ifTrue: [i:=0] ifFalse: [i:=i+1]."
	self initColor.
	self majColor.
	"self majColor2."
	"i > 50
	ifTrue:[self majColor2]."! !

!MorphFire methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/13/2010 15:51'!
stepTime
	^self sleepTime.! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
taille
	^ taille! !

!MorphFire methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2010 19:07'!
taille: anObject
	taille := anObject! !

Object subclass: #STdoc
	instanceVariableNames: 'class stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Summer2010-STdoc'!

!STdoc commentStamp: 'BenjaminVanRyseghem 6/10/2010 15:23' prior: 0!
Un STdoc est un simili Javadoc.!

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:46'!
commentsFrom2: aMethod
	"Return the first comment of a method"
	"self commentsFrom2: (Point>>#dist:)"
	^ aMethod methodClass firstCommentAt: aMethod selector.
	
	! !

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:40'!
commentsFrom: aMethod
	"Return the first comment of a method"

	|source result boolWriting boolFirstComment start|
	source := aMethod getSource asString.
	result := ''.
	boolWriting := false.
	boolFirstComment := true.
	start := ((source lineNumber: 1) size +1).
	
	( start to: source size) do:
		[:i|
			(source at: i) = $"
				ifTrue: 
					[
						boolWriting 
							ifTrue: [boolWriting := false]	
							ifFalse: 
							[
								boolFirstComment 
									ifTrue: 
									[
										boolFirstComment := false.
										boolWriting := true.
									]						
							]
					]
				ifFalse: 
					[
						boolWriting
							ifTrue: [result := result, ((source at: i) asString)]
							ifFalse: 
							[
								(source at: i) isSeparator
								ifFalse:
								[
									boolFirstComment := false.
									
								]
							]
					]
		].
	^result withCRs.! !

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:40'!
nameOf: aMethod
	"Return the name of method"
	"self  nameOf: (Point>>#dist:)"
	
	^ aMethod selector
	"
	|source result boolWriting|
	source := (aMethod name subStrings: '>>' ) at: 2.
	result := ''.
	boolWriting := true.
	
	(1 to: source size-1) do:
		[:i|
			((source at: i+1) asString ) = ''
				ifTrue: [boolWriting := false]
				ifFalse: [boolWriting 
								ifTrue: [result := result, ((source at: i) asString)] 
								ifFalse: []
				]
		
		].
	^result. "! !

!STdoc classSide methodsFor: 'parsing' stamp: 'sd 6/14/2010 17:52'!
new

	^ super new initialize ! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/13/2010 15:38'!
build

	self displayHeader.
	self displayInstanceVariables.
	self displayClassVariables.
	self displayInstanceMethods.
	self displayClassMethods. 
	self displaySuperClass. 
	self displaySubClasses.
	^self stream contents! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:09'!
classMethods
	^self myclass class methods.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:37'!
classVariables
	^self myclass classVarNames.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:15'!
comment

	^self myclass class comment.! !

!STdoc methodsFor: 'display' stamp: 'sd 6/14/2010 17:48'!
displayClassMethods

	self classMethods isEmpty
		ifFalse: [
			self stream nextPutAll: '----------------------------------------------';cr.
			self stream nextPutAll: 'Mthodes d''instance :';cr.
			self classMethods do: [:each|
				self stream nextPutAll:'     '; nextPutAll:(self class nameOf: each);cr.
				(self class commentsFrom: each) isEmpty
					ifTrue: [ self stream 
									nextPutAll: '     '; 
									nextPutAll:('Just another uncommented method');cr;cr.] 
					ifFalse: [ self stream 
									nextPutAll: '     '; 
									nextPutAll:(self class commentsFrom: each);cr;cr]]].! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displayClassVariables
	
	self classVariables size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------';cr.
		self stream nextPutAll: 'Variables de classe :'; cr.
		self classVariables do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll: each; cr.
		].
	].! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:37'!
displayHeader
		self stream nextPutAll: self name; cr.
		self stream nextPutAll: self comment;cr;cr.! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displayInstanceMethods

	self instanceMethods size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Mthodes d''instance :'; cr.
		self instanceMethods do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll:(STdoc nameOf: each); cr.
			(STdoc commentsFrom: each) = ''
			ifTrue: 
			[
				self stream nextPutAll: '     '; nextPutAll:('Just another uncommented method');cr;cr.
			] 
			ifFalse: 
			[
				self stream nextPutAll: '     '; nextPutAll:(STdoc commentsFrom: each);cr;cr.
			].
			
		]
	].! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displayInstanceVariables
	
	self instanceVariables size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Variables d''instance :';cr.
		self instanceVariables do:
		[:each|
			self stream nextPutAll: '     '; nextPutAll: each; cr.
		].
	].
! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displaySubClasses
	
	self subClasses size = 0
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'SubClasses :'; cr.
		"self subClasses do:
		[:each|
			result := result, '     ',each name, String cr.
			result := result, '     ',('Afficher la doc: (STdoc new with: ',each name,';build)'), String cr, String cr.
		]."
		
	].! !

!STdoc methodsFor: 'display' stamp: 'BenjaminVanRyseghem 6/13/2010 15:36'!
displaySuperClass
	
	self superClass isNil
	ifFalse:
	[
		self stream nextPutAll: '----------------------------------------------'; cr.
		self stream nextPutAll: 'Superclass :'; cr.
		self stream nextPutAll: '     '; nextPutAll: (self superClass name); cr.
		"result := result, '     ',('Afficher la doc: (STdoc new with: ',self superClass name,';build)'), String cr, String cr."
	].! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/11/2010 16:18'!
export

	self export: ((self name),'.txt').! !

!STdoc methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 6/11/2010 16:17'!
export: aString
	|temp|
	temp := self build.
	StandardFileStream 
	fileNamed: aString
	do:[:str|str nextPutAll: temp.]! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:35'!
initialize

stream := WriteStream on: String new.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:22'!
instanceMethods
	^self myclass methodDict values.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:09'!
instanceVariables
	^self myclass instVarNames.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:06'!
myclass
	^ class
! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:25'!
myclass: anObject
"Setter"
	class := anObject! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:13'!
name

	^self myclass name.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:34'!
stream
	^ stream! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/13/2010 15:34'!
stream: anObject
	stream := anObject! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:10'!
subClasses
	^self myclass subclasses.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:10'!
superClass
	^self myclass superclass.! !

!STdoc methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/10/2010 15:04'!
with: aClass 

class := aClass .! !

BorderedMorph subclass: #MyRoundedMorph
	instanceVariableNames: 'stringMorph linesCollection refresh'
	classVariableNames: 'canMakeAChild'
	poolDictionaries: ''
	category: 'Summer2010-Morph'!

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/15/2010 13:31'!
addLine: aLiaison.

	self linesCollection add: aLiaison.
	aLiaison openInWorld.
	self addMorphBack: aLiaison! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/15/2010 13:24'!
clearLines
	
	self linesCollection isNil
	ifFalse:[
		self linesCollection do:
		[:each| each delete]].! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/17/2010 04:33'!
delete
	
	super delete.
	self stringMorph isNil
	ifFalse:[	self stringMorph delete ].
	self deleteLines.
	self destroy.! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/17/2010 04:33'!
deleteLines

	self linesCollection do:[:each |
			each source = self
			ifTrue:[each destination delete].
			each delete]! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/17/2010 04:33'!
destroy

		linesCollection := OrderedCollection new.! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/17/2010 04:07'!
handleEvent: anEvent
	"Handle the given event"
	
	anEvent isMouse
	ifTrue:[
			anEvent isDraggingEvent
			ifTrue:[self linesStartStepping]
			ifFalse:[self linesStopStepping].
			anEvent blueButtonPressed
				ifTrue: [
					canMakeAChild
					ifTrue:[self makeAChild].
					canMakeAChild := false]
				ifFalse:[canMakeAChild := true]].
	
	
	
	
	^anEvent sentTo: self.! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/17/2010 04:33'!
initialize 

	super initialize .
	self useRoundedCorners.
	linesCollection := OrderedCollection new.
	canMakeAChild := true.! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:40'!
linesCollection
	^ linesCollection! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:40'!
linesCollection: anObject
	linesCollection := anObject! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/17/2010 03:02'!
linesStartStepping

	self linesCollection do:[:each| each startStepping].! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/17/2010 03:02'!
linesStopStepping

	self linesCollection do:[:each| each stopStepping].! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/17/2010 04:09'!
makeAChild
	|child childLabel childPoint childColor|
	
	childLabel := self stringMorph contents, '''s child'.
	childPoint := ((self bottomRight x) + 75)@((self bottomRight y) + 75).
	childColor := self color.
	
	child := self class new with: childLabel where: childPoint color: childColor.
	child openInWorld.
	
	Liaison new source: self; destination: child; draw; openInWorld.! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/15/2010 12:13'!
openInWorld 

	super openInWorld.
	self stringMorph isNil
	ifFalse:[	
			self stringMorph openInWorld .
			self addMorphFront: (self stringMorph)].! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:05'!
stringMorph
	^ stringMorph! !

!MyRoundedMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/15/2010 12:05'!
stringMorph: anObject
	stringMorph := anObject! !

!MyRoundedMorph methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 6/15/2010 12:22'!
with: aString where: aPoint color: aColor
	|margeX margeY width height|
	
	margeX := 10.
	margeY := 15.

	self stringMorph: aString asMorph.
	self stringMorph 
		topLeft: ((aPoint x+margeX)@(aPoint y+margeY));
		color: aColor negated.

	width := self stringMorph width + (2 * margeX).
	height := self stringMorph height + (2 * margeY).
	
	self 	bounds: (aPoint corner: ((aPoint x+width)@(aPoint y+height)));
			color: aColor.
! !
